/*
TASK: coins
LANG: C++
*/
#include <cstdio>

const int MAXN = 1 << 20;

int k , l , m;
int dp[MAXN];

void read() {
    scanf ("%d%d%d",&k,&l,&m);
}

void init() {
    int i;
    
    dp[0] = 1;
    for (i=1;i<MAXN;i++)
        if ( dp[i - 1] == 1 || (i >= l && dp[i - l] == 1) || (i >= k && dp[i - k] == 1) )
            dp[i] = 2;
        else
            dp[i] = 1;
}

void solve() {
    int n;
    
    while ( m -- ) {
        scanf ("%d",&n);
        
        if ( dp[n] == 2 ) 
            printf ("A");
        else
            printf ("B");
    }
    
    printf ("\n");
}

int main() {
    read();
    init();
    solve();
    
    return 0;
}
