/*
TASK: rec
LANG: C++
*/
#include <cstdio>

const int MAXN = 1 << 10;

inline int abs ( int x ) { return (x < 0) ? -x : x; }

int n;
int a[MAXN][2];

int dp[MAXN][2];

void read() {
    int i;
    
    scanf ("%d",&n);
    for (i=1;i<=n;i++)
        scanf ("%d%d",&a[i][0],&a[i][1]);  
}

void solve() {
    int i;
    int x , y;
    
    dp[1][0] = a[1][1];
    dp[1][1] = a[1][0];
    
    for (i=2;i<=n;i++) {
        x = dp[i - 1][0] + abs ( a[i][0] - a[i - 1][0] );
        y = dp[i - 1][1] + abs ( a[i][0] - a[i - 1][1] );
        if ( x > y )
            dp[i][0] = x + a[i][1];
        else
            dp[i][0] = y + a[i][1];
            
        x = dp[i - 1][0] + abs ( a[i][1] - a[i - 1][0] );
        y = dp[i - 1][1] + abs ( a[i][1] - a[i - 1][1] );
        if ( x > y )
            dp[i][1] = x + a[i][0];
        else
            dp[i][1] = y + a[i][0];
    }
    
    if ( dp[n][0] > dp[n][1] )
        printf ("%d\n",dp[n][0]);
    else
        printf ("%d\n",dp[n][1]);
}

int main() {
    read();
    solve();
    
    return 0;
}
