/*
TASK:closest
LANG:C++
*/

#include <iostream>
using namespace std;

int n;
int A[64], B[64];
int dig[16], wd[16];
int gen[64];

bool geneq( int );
bool genmax( int );

int getmin()
{
	for ( int i = 0; i <= 9; i++ )
		if ( wd[i] > 0 )
			return i;
	return -1;
}

int getmax()
{
	for ( int i = 9; i >= 0; i-- )
	{
		if ( wd[i] > 0 )
			return i;
	}
	return -1;
}

int find_closest( int a )
{
	int i = a, j = a;
	while ( i <= 9 )
	{
		if ( wd[i] > 0 )
			break;
		i++;
	}
	
	while ( j >= 0 )
	{
		if ( wd[j] > 0 )
			break;
			j--;
	}
	
	if ( ( i - a < a - j ) && ( i <= 9 ) )
		return i;
	if ( ( i - a >= a - j ) && ( j >= 0 ) )
		return j;
	return -1;
}

bool genmin( int j )
{
	int i, k;
	for ( i = j; i <= n; i++ )
	{
		k = getmin();
		gen[i] = k;
		wd[k]--;
	}

	i = 1;
	while ( ( A[i] == gen[i] ) && ( i <= n ) )
	{
		i++;
	}
	if ( ( ( i <= n ) && ( gen[i] >= A[i] ) && ( gen[1] != 0 ) ) || ( ( i == n + 1 ) && ( gen[1] != 0 ) ) )
	{
		return 1;
	}
	return 0;
}

bool genmax( int j )
{
	char p;
	int i, k;
	for ( i = j; i <= n; i++ )
	{
		k = getmax();
		gen[i] = k;
		wd[k]--;
	}
	i = 1;
	while ( ( A[i] == gen[i] ) && ( i <= n ) )
		i++;
	if ( i == n + 1 )
		if ( prev_permutation( gen + 1, gen + n + 1 ) == 0 )
			p = 0;
	
	i = 1;
	while ( ( A[i] == gen[i] ) && ( i <= n ) )
	{
		i++;
	}
	if ( ( i <= n ) && ( gen[i] < A[i] ) && ( gen[1] != 0 ) && (  p == 1 ) )
	{
		return 1;
	}
	return 0;
}

bool geneq( int j )
{
	int i, a, b;
	
	if ( j > n )
		return 1;
	
	a = A[j];
	if ( wd[a] > 0 )
	{
		gen[j] = a;
		wd[a]--;
		return geneq( j + 1 );
	}
	else
	{
		b = find_closest( a );
		if ( b != -1 )
		{
		    wd[b]--;
			gen[j] = b;
			if ( b > a )
				return genmin( j + 1 );
			else
				return genmax( j + 1 );
		}
	}
}

int main()
{
	n = 0;
	int i, j;
	bool xx;
	char p;
	
	for ( i = 1; i <= 64; i++ )
	{
		dig[i] = 0;
		wd[i] = 0;
	}
	
	do
	{
		cin.get( p );
		if ( p != '\n' )
			A[++n] = p - '0';
	}
	while ( p != '\n' );
	
	n = 0;
	do
	{
		cin.get( p );
		if ( p != '\n' )
		{
			j = p - '0';
			B[++n] = j;
			dig[j]++;
		}
	}
	while ( p != '\n' );
	
	for ( i = 0; i <= 9; i++ )
		wd[i] = dig[i];
	
	for ( i = A[1]; i <= 9; i++ )
	{
		if ( dig[i] > 0 )
		{
			if ( i == A[1] )
			{
  				gen[1] = i;
				wd[i]--;
				xx = geneq( 2 );
				for ( j = 0; j <= 9; j++ )
					wd[j] = dig[j];
				if ( xx )
					break;
			}
			else
			{
				gen[1] = i;
				wd[i]--;
				xx = genmin( 2 );
				for ( j = 0; j <= 9; j++ )
					wd[j] = dig[j];
				if ( xx )
					break;
				wd[i]++;
			}
		}
	}
	
	i = 1;
	while ( ( A[i] == gen[i] ) && ( i <= n ) )
	{
		i++;
	}
	if ( ( ( i <= n ) && ( gen[i] >= A[i] ) && ( gen[1] != 0 ) ) || ( ( i == n + 1 ) && ( gen[1] != 0 ) ) )
	{
		for ( i = 1; i <= n; i++ )
		{
			cout << gen[i];
		}
		cout << '\n';
	}
	else
		cout << '0' << endl;
	
	for ( i = 0; i <= 9; i++ )
		wd[i] = dig[i];
	for ( i = 1; i <= n; i++ )
		gen[i] = 0;
	
	for ( i = A[1]; i >= 1; i-- )
	{
		if ( dig[i] > 0 )
		{
			if ( i == A[1] )
			{
				gen[1] = i;
				wd[i]--;
				xx = geneq( 2 );
				for ( j = 0; j <= 9; j++ )
					wd[j] = dig[j];
				if ( xx )
					break;
			}
			else
			{
				gen[1] = i;
				wd[i]--;
				xx = genmax( 2 );
				for ( j = 0; j <= 9; j++ )
					wd[j] = dig[j];
				if ( xx )
					break;
			}
		}
	}
	
	p = 1;
	
	i = 1;
	while ( ( A[i] == gen[i] ) && ( i <= n ) )
		i++;
	if ( i == n + 1 )
		if ( prev_permutation( gen + 1, gen + n + 1 ) == 0 )
			p = 0;
	
	i = 1;
	while ( ( A[i] == gen[i] ) && ( i <= n ) )
	{
		i++;
	}
	if ( ( i <= n ) && ( gen[i] < A[i] ) && ( gen[1] != 0 ) && (  p == 1 ) )
	{
		for ( i = 1; i <= n; i++ )
			cout << gen[i];
		cout << '\n';
    }
    else
    	cout << '0' << endl;
	
	return 0;
}
