/*
TASK:closest
LANG:C++
*/
#include <iostream>

#define fru(j,n) for(int j=0;j<n;++j)

using namespace std;

string a,b;
string brak = "0";
int n;

int cb[10];

string zmienodejmij (string e)
{
    fru(i,n) e[i]-='0';
    return e;
}
string zmiendodaj (string e)
{
    if(e[0]==brak[0]) return e;
    fru(i,n) e[i]+='0';
    return e;
}
////znajdowanie x ---------------------------------------------------------------------
int minimum()
{
    fru(i,10) if(cb[i])
    {
        --cb[i];
        return i;
    }
}
int maximum(int w)
{
    for(++w;w<10;++w) if(cb[w]) return w;
    return -1;
}

string xdokoncz(string ret, int i)
{
    for(;i<n;++i) ret[i]=minimum();
    return ret;
}

string xpopraw(string ret, int i)
{
    int q;
    for(int j=i;j>=0;--j)
    {
        ++cb[a[j]];
        q=maximum(a[j]);
        if(q!=-1)
        {
            ret[j]=q;
            --cb[q];
            return xdokoncz(ret,j+1);
        }
    }
    return brak;
}

string findx()
{
    string ret=a;
    if(b==a) return a;
//czesc wlasciwa ------------ 
    fru(i,n) 
    {
        if(cb[a[i]]==0)
        {
            for(int q=a[i];q<10;++q) if(cb[q]) 
            {
                cb[q]--;
                ret[i]=q;
                return xdokoncz(ret,i+1);
            }
            
            return xpopraw(ret,i);
        }
        else --cb[a[i]];
    }
    return brak;
}
////znajdowanie y ---------------------------------------------------------------------

int mniejnizja(int w)
{
    for(--w;w>=0;--w) if(cb[w]) return w;
    return -1;
}

string ydokoncz(string ret, int i)
{
    int q;
    for(;i<n;++i)
    {
        q=mniejnizja(11);
        ret[i]=q;
        --cb[q];        
    }
    return ret;    
}
string ypopraw(string ret, int i)
{
    int q;
    for(;i>=0;--i)
    {
        --cb[a[i]];
        q=mniejnizja(a[i]);
        if(q!=-1)
        {
            ret[i]=q;
            return ydokoncz(ret,i+1);
        }
    }
    return brak;
}


string findy()
{
    string ret=a;
    int q;
    if(b==a) return brak;
    fru(i,n)
    {
        if(cb[a[i]]==0)
        {
            q=mniejnizja(a[i]);
            if(i==0)
            {
                if(q==0) return brak;
            }
            if(q!=-1)
            {
                ret[i]=q;
                --cb[q];
                return ydokoncz(ret,i+1);
            }
            return ypopraw(ret,i);
        }
        else --cb[a[i]];
    }
    return brak;
}


int main()
{
do
{
    cin>>a>>b;
    n=a.size();
    a=zmienodejmij(a);
    b=zmienodejmij(b);
    fru(i,10) cb[i]=0; fru(i,n) ++cb[b[i]];
    sort(b.begin(),b.end());
    string x=zmiendodaj(findx());
    fru(i,10) cb[i]=0; fru(i,n) ++cb[b[i]];
    string y=zmiendodaj(findy());
    cout<<x<<endl<<y<<endl;
}
while(0);
    return 0;
}
/*
3075
6604
::
4066
0

35432
34231
::
41233
34321 

99998
89998
::
0
99988

1234
1234
::
1234
0

3000203
4562454
::
4244556
2655444

1234
4321
::
1234
0

5678900
6740000
::
6000047
4760000

5678900
6780000
::
6000078
0

*/
