/*
TASK:rec
LANG:C++
*/
#include <cstdio>
#include <algorithm>

#define fru(j,n) for(int j=0;j<n;++j)
#define STOP scanf("%d",&END);

using namespace std;


typedef long long LL;

int END;

const int MAXN = 1005;
int n;

LL D[MAXN][2];
pair<int,int> W[MAXN][2];
//<x,y>  -- wysokosc, dlgosc
void solve()
{
    fru(i,n) fru(b,2) D[i][b]=0;
    fru(b,2) D[0][b]=W[0][b].second;
    
    int b;
    LL f1,f2;
    for(int i=1;i<n;++i) for(b=0;b<2;++b)
    {
        f1=D[i-1][0]+abs(W[i][b].first-W[i-1][0].first);
        f2=D[i-1][1]+abs(W[i][b].first-W[i-1][1].first);
        D[i][b]=max(f1,f2)+W[i][b].second;
    }
}

int main()
{
    scanf("%d",&n);
    fru(i,n) 
    {
        scanf("%d%d",&W[i][0].first,&W[i][0].second);
        W[i][1].first =W[i][0].second;
        W[i][1].second=W[i][0].first;
    }
    solve();
    printf("%lld\n",max(D[n-1][0],D[n-1][1]));
    int b=max(W[0][1].first,W[0][1].second);
    return 0;
}
/*
5
2 5
3 8
1 10
7 14
2 5
*/
/*
1
4 5
*/
