/*
TASK: closest
LANG: C++
*/
#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 7;

int n;
char q[MAXN];
char w[MAXN];

int a[MAXN];
int b[MAXN];

int used[16];

void read() {
    int i;
    
    scanf ("%s",q);
    scanf ("%s",w);
    
    n = (int)strlen ( q );
    
    for (i=0;i<n;i++) a[i] = q[i] - '0';
    for (i=0;i<n;i++) b[i] = w[i] - '0';
}

void solve1() {
    int i , j;
    
    for (i=n - 1;i>=-1;i--) {
        for (j=0;j<10;j++)  
            used[j] = 0;
            
        for (j=0;j<n;j++)   
            ++ used[ b[j] ];
        
        for (j=0;j<=i;j++)  
            -- used[ a[j] ];
        
        for (j=0;j<10;j++)
            if ( used[j] < 0 )
                break;
                
        if ( j != 10 ) continue;
        if ( i != n - 1 )
            for (j=a[i + 1] + 1;j<10;j++)
                if ( used[j] ) break;
                
        if ( i == n - 1 || j != 10 ) 
            break;
    }
    
    if ( i == -2 ) {
        printf ("0\n");
        return ;
    }
    
    for (j=0;j<=i;j++)
        printf ("%c",a[j] + '0');
        
    if ( i == n - 1 ) {
        printf ("\n");
        return ;
    }
    for (j=a[i + 1] + 1;j<10;j++)
        if ( used[j] ) break;
        
    if ( j == 10 ) {
        printf ("0\n");
        return ;
    }
        
    -- used[j];
    printf ("%c",j + '0');
    
    for (j=0;j<10;j++)
        while ( used[j] ) {
            -- used[j];
            printf ("%c",j + '0');
        }
        
    printf ("\n");
}

void solve2() {
    int i , j;
    
    for (i=n - 2;i>=-1;i--) {
        for (j=0;j<10;j++)  
            used[j] = 0;
            
        for (j=0;j<n;j++)   
            ++ used[ b[j] ];
        
        for (j=0;j<=i;j++)  
            -- used[ a[j] ];
        
        for (j=0;j<10;j++)
            if ( used[j] < 0 )
                break;
                
        if ( j != 10 ) continue;
        if ( i != n - 1 )
            for (j=a[i + 1] - 1;j>=0;j--)
                if ( used[j] ) break;
                
        if ( i == n - 1 || j != -1 ) 
            break;
    }
    
    for (j=0;j<=i;j++)
        printf ("%c",a[j] + '0');
        
    if ( i == n - 1 ) {
        printf ("\n");
        return ;
    }
    for (j=a[i + 1] - 1;j>=0;j--)
        if ( used[j] ) break;
        
    if ( j == -1 || (i == -1 && !j) ) {
        printf ("0\n");
        return ;
    }
        
    -- used[j];
    printf ("%c",j + '0');
    
    for (j=9;j>=0;j--)
        while ( used[j] ) {
            -- used[j];
            printf ("%c",j + '0');
        }
        
    printf ("\n");
}

int main() {
    read();
    solve1();
    solve2();
    
    return 0;
}
