/*
TASK: closest
LANG: C++
*/
#include <iostream>
#include <string>
#include <queue>
using namespace std;

struct s {int a,ind;};

struct Cmp 
{
 bool operator () (const s &a, const s &b)
  {
   return a.a > b.a;      // po - malko //
  }
};

struct cmp 
{
 bool operator () (const s &a, const s &b)
  {
   return a.a < b.a;      // po - golqmo //
  }
};

int sol;
string a,b;
int n[64],m[64],size, used[64], used1[64], solmin[64],solmax[64],kmin,kmax, pmin, pmax;
 
void solve_min (int lvl)
{
 if (kmin) return ;
 if (lvl == size && pmin) 
  {
   kmin = 1; 
   for (int i=0; i < size ; i++) 
    printf ("%d", solmin [i]);
   printf ("\n"); 
 
   return;
  }
 
 int is [16];
 memset (is,0,sizeof (is));
 priority_queue <s , vector <s>, cmp> pq;
 
 for (int i=0; i < size ; i++)
  if ( !is[ m[i] ])
   {
     if (!pmin)
      {
       if (m[i] <= n[lvl] && !used[i])
        {
         is[m[i]] = 1;   
         
         s t;
         t.a = m[i];
         t.ind = i;
         pq.push (t);     
        }
      }      
     else 
      if (!used[i])
       {
        is[m[i]] = 1;    
         
        s t;
        t.a = m[i];
        t.ind = i;
        pq.push (t);    
       }
   } 
 while (pq.size ())
  {
   s t = pq.top(); pq.pop ();
   if (!t.a && !lvl) continue;
   used[t.ind] = 1;
   solmin [lvl] = t.a;
   if (t.a < n[lvl]) pmin = 1;
   
   solve_min (lvl + 1);
   
   if (kmin) return ;
   used[t.ind] = 0;      
  }
}

void solve_max (int lvl)
{
 if (kmax) return ;
 if (lvl == size) 
  {
   kmax = 1; 
   for (int i=0; i < size ; i++) 
    printf ("%d", solmax [i]);
   printf ("\n"); 

   return;
  }
 
 int is [16];
 memset (is,0,sizeof (is));

 priority_queue <s , vector <s>, Cmp> pq;
 
 for (int i=0; i < size ; i++)
  if ( !is[ m[i] ])
   {
    if (!pmax)
     {
      if (m[i] >= n[lvl] && !used1[i] )
       {
        is[ m[i] ] = 1;
        
        s t;
        t.a = m[i];
        t.ind = i;
        pq.push (t);     
       }      
     }
    else 
     if (!used1[i])
      {
       is[ m[i] ] = 1;
       
       s t;
       t.a = m[i];
       t.ind = i;
       pq.push (t);     
      }    
   }
 while (pq.size ())
  {
   s t = pq.top(); pq.pop ();
   used1[t.ind] = 1;
   solmax [lvl] = t.a;
   if (t.a > n[lvl]) pmax = 1;

   solve_max (lvl + 1);
   
   if (kmax) return ;
   used1[t.ind] = 0;      
  }
}

int main ()
{
 cin >> a >> b;
 size = a.size ();
 for (int i=0; i < size ; i++)
   {
    n[i] = a[i] - '0';         
    m[i] = b[i] - '0';
   }

 solve_max (0);
 if (!kmax) printf ("0\n");
 
 solve_min (0);
 if (!kmin) printf ("0\n");
 
 return 0;    
}
